#
#       HBS REDUCTION SUB ROUTINE
#
#       Display and shift images: hbsdisplay.cl
#
#       1995/10/05      K.Kawabata
#       1996/06/29      K.Kawabata Ver. 1.10  (enhance-scaling)
#       1996/11/06      K.Kawabata (delete mode)
#
#
procedure hbsdisplay( inlist )

file inlist	{ prompt = "Input image list" }

begin

  string fn, tmp_fn, buf, buf1
  int xsft, ysft
  int x
  int flag_xyscale = 0
  int flag_zscale = 0
  real xscale=1.00
  real yscale=1.00
  real xscaletmp, yscaletmp
  real zmin=1000.
  real zmax=5000.
  real zmintmp, zmaxtmp

  print( "" )
  print( "---------------------------------" )
  print( " Display and shift(if necessary)" )
  print( "---------------------------------" )
  print( "" )

  buf = " "
  list = inlist
  tmp_fn = mktemp( "hbs.tmp.image." )
  xscaletmp = xscale
  yscaletmp = yscale

  print( "Set Magnify Scaling ? ( [y]:yes [RET]:no )" )
  x = scan( buf )
  while( x != 0 && buf != "y" && buf != "n" )
    x = scan( buf )
  if( buf == "y" )
  {
    flag_xyscale = 1
    print( "Input xmag and ymag (default "//xscale//" "//yscale//")" )
    x = scan( buf, buf1 )
    while( x != 0 && x != 2 )
      x = scan( buf, buf1 )
    if( x == 2 ){
      xscale = real( buf )
      yscale = real( buf1 )
    }
  }
  print( "Set Intensity Scaling ? ( [y]:yes [RET]:no )" )
  x = scan( buf )
  while( x != 0 && buf != "y" && buf != "n" )
    x = scan( buf )
  if( buf == "y" )
  {
    flag_zscale = 1
    print( "Input z1 and z2 (default "//zmin//" "//zmax//")" )
    x = scan( buf, buf1 )
    while( x != 0 && x != 2 )
      x = scan( buf, buf1 )
    if( x == 2 ){
      zmin = real( buf )
      zmax = real( buf1 )
    }
  }

  while( fscan(list, fn) != EOF && buf != "q" )
  {
    print( "IMAGE- "//fn )
    if( flag_xyscale == 0 && flag_zscale == 0 )
      display( fn, 1, zscale+, zrange+,\
               fill-, xmag=xscale, ymag=yscale )
    if( flag_xyscale == 1 && flag_zscale == 0 )
      display( fn, 1, zscale+, zrange+,\
               fill-, xmag=xscale, ymag=yscale )
    if( flag_xyscale == 0 && flag_zscale == 1 )
      display( fn, 1, zscale-, zrange-, z1=zmin, z2=zmax,\
               fill- )
    if( flag_xyscale == 1 && flag_zscale == 1 )
      display( fn, 1, zscale+, zrange+, z1=zmin, z2=zmax,\
               fill-, xmag=xscale, ymag=yscale )

query :
    print("[RET]:next [i]:intensity [m]:magnify [s]:shift  [d]:delete >>")
    x = scan(buf)
    while( x != 0 && buf != "s" && buf != "d" && buf != "i" && buf != "m" )
      x = scan(buf)
    if( buf == "i" )
    {
      print( "Input z1 and z2 (default "//zmin//" "//zmax//")" )
      x = scan( buf, buf1 )
      while( x != 0 && x != 2 )
        x = scan( buf, buf1 )
      if( x == 2 ){
        zmintmp = real( buf )
        zmaxtmp = real( buf1 )
      }
      display( fn, 1, zscale-, zrange-, z1=zmintmp, z2=zmaxtmp,\
              fill-, xmag=xscale, ymag=yscale )
      goto query
    }
    if( buf == "m" )
    {
      print( "Input xmag and ymag (default "//xscaletmp//" "//yscaletmp//")" )
      x = scan( buf, buf1 )
      while( x != 0 && x != 2 )
        x = scan( buf, buf1 )
      if( x == 2 ){
        xscaletmp = real( buf )
        yscaletmp = real( buf1 )
      }
      display( fn, 1, zscale+, zrange+,\
               fill-, xmag=xscaletmp, ymag=yscaletmp )
      goto query
    }
    if( buf == "s" )
    {
shift :
      print("How shift ? ( x, y )  >>")
      while( scan( xsft, ysft ) != 2 ) {}
      imshift( input=fn, output=tmp_fn, xshift=xsft, yshift=ysft,\
               interp_type = "linear" )
      display( tmp_fn, 1 )
      print("[y]:update and next  [r]:retry  [n]:no shift  >>")
      x = scan(buf)
      while( buf != "y"  && buf != "r" && buf != "n")
        x = scan(buf)
      if( buf == "y" )
      {
        imdelete( fn )
        imrename( oldname=tmp_fn, newname=fn, ver- )
      }
      if( buf == "r" )
      {
        imdelete( tmp_fn )
        goto shift
      }
      if( buf == "n" )
      {
        imdelete( tmp_fn )
      }
    }
    if( buf == "d" )
      imdelete( fn, ver- )
  }
end
